<?php

namespace jrosset\ArrayClasses;

/**
 * An immutable array with insensitive case cell name
 */
class ImmutableInsensitiveCaseArrayClass implements IImmutableArrayClass {
    use TImmutableInternalArray {
        has as private has__TImmutableInternalArray;
        get as private get__TImmutableInternalArray;
    }

    /**
     * @inheritDoc
     */
    public function has ($cellName): bool {
        return $this->has__TImmutableInternalArray(mb_strtolower($cellName));
    }
    /**
     * @inheritDoc
     */
    public function get ($cellName, ?bool $throwsForNonExistentElement = null) {
        return $this->get__TImmutableInternalArray(mb_strtolower($cellName), $throwsForNonExistentElement);
    }

    /**
     * @inheritDoc
     */
    public function toMutable (): IArrayClass {
        return new InsensitiveCaseArrayClass($this->array, $this->throwsForNonExistentElement());
    }
}